﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Telerik.WinControls.UI

Namespace TelerikWinFormsApp9
	Partial Public Class RadForm1
		Inherits Telerik.WinControls.UI.RadForm

		Public Sub New()
			InitializeComponent()
			AddHandler radTreeView1.MouseDown, AddressOf RadTreeView1_MouseDown
			AddHandler radTreeView1.MouseMove, AddressOf RadTreeView1_MouseMove
			radPanel1.AllowDrop = True
			AddHandler radPanel1.DragEnter, AddressOf RadPanel1_DragEnter
			AddHandler radPanel1.DragDrop, AddressOf RadPanel1_DragDrop
		End Sub
		Private mouseDownPosition As Point
		Private Sub RadTreeView1_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
			Dim node = TryCast(radTreeView1.ElementTree.GetElementAtPoint(mouseDownPosition), TreeNodeElement)
			If node IsNot Nothing AndAlso IsRealDrag(mouseDownPosition, e.Location) Then
				radTreeView1.DoDragDrop(node, DragDropEffects.Move)
			End If
		End Sub
		Private Sub RadTreeView1_MouseDown(ByVal sender As Object, ByVal e As MouseEventArgs)
			Me.mouseDownPosition = e.Location
		End Sub
		Private Shared Function IsRealDrag(ByVal mousePosition As Point, ByVal initialMousePosition As Point) As Boolean
			Return (Math.Abs(mousePosition.X - initialMousePosition.X) >= SystemInformation.DragSize.Width) OrElse (Math.Abs(mousePosition.Y - initialMousePosition.Y) >= SystemInformation.DragSize.Height)
		End Function

		Private Sub RadPanel1_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs)
			Dim draggedItem = TryCast(e.Data.GetData(GetType(TreeNodeElement)), TreeNodeElement)
			If draggedItem IsNot Nothing Then
				radPanel1.Text = draggedItem.Data.Text
			End If
		End Sub

		Private Sub RadPanel1_DragEnter(ByVal sender As Object, ByVal e As DragEventArgs)
			Dim draggedItem = TryCast(e.Data.GetData(GetType(TreeNodeElement)), TreeNodeElement)
			If draggedItem IsNot Nothing Then
				e.Effect = DragDropEffects.Move

			End If
		End Sub
	End Class
End Namespace
